;GridMove
;By jgpaiva
;date: May 2006
;function: Adjusts windows to a predefined or user-defined desktop grid.


  ;;options:
  MButtonDrag := True ;to be able to drag a window using the 3rd mouse button
  LButtonDrag := True ;to be able to drag a window by it's title
  EdgeDrag := True ;to be able to bring the grid up when dragging a window to the edge
  EdgeTime := 1000
  ShowGroupsFlag := True ;configures the showing or not of the groups
  TitleSize := 100
  GridName = 3Part
  GridOrder =2PartVertical,3Part,Edge,DualScreen
  UseCommand := True
  CommandHotkey = #g
  UseFastMove := True
  FastMoveModifiers = #
  Exceptions = QuarkXPress,Winamp v1.x,Winamp PE,Winamp Gen,Winamp EQ
  ;;end of options

ScriptVersion = 1.19.30

  
  ;;Install files
  FileCreateDir,Grids
  FileCreateDir,Images
  FileCreateDir,Plugins
  FileInstall,Images\Grid.bmp,Images\Grid.bmp,1
  FileInstall,Grids\2 Part-Vertical.grid,Grids\2 Part-Vertical.grid,1
  FileInstall,Grids\2 Part-Horizontal.grid,Grids\2 Part-Horizontal.grid,1
  FileInstall,Grids\EdgeGrid.grid,Grids\EdgeGrid.grid,1
  FileInstall,Grids\RunDemo.grid,Grids\RunDemo.grid,1
  FileInstall,Grids\axcrusik_s_grid.grid,Grids\axcrusik_s_grid.grid,1
  FileInstall,Plugins\WindowPositions.exe,Plugins\WindowPositions.exe
  FileInstall,Images\Cody.png,Images\Cody.png,1
  FileInstall,GridMoveHelp.txt,GridMoveHelp.txt,1
  FileInstall,Plugins\MinimizeWindow.exe,Plugins\MinimizeWindow.exe,1


  GetScreenSize()       ;get the size of the monitors
  GetMonitorSizes()
  OSDcreate()
  GoSub, ReadIni
  SetWinDelay, -1
  SetBatchLines, -1



  If 0 = 1
    GridName = %1%

  ;;tray menu:
  Menu, Tray, Add, About/Help, AboutHelp
  Menu, Tray, Default, About/Help
  Menu, Tray, Tip, GridMove V%ScriptVersion%
  CreateTemplatesMenu()
  Menu, Tray, Add, Templates, :Templates
  IfExist Images\gridmove.ico  
    Menu, Tray, Icon,Images\gridmove.ico
  Menu, Tray, NoStandard
  CreateOptionsMenu()
  Menu, Tray, Add, Options, :Options
  CreateHotkeysMenu()
  Menu, Tray, Add, Hotkeys, :Hotkeys
  Menu, Tray, Add, Reload, ReloadProgram
  Menu, Tray, Add, Exit, ExitProgram

GoSub, ApplyGrid

Mutex := False
GroupsShowing := False
EdgeFlag := True
MousePositionLock := False


Sysget, CaptionSize,4  ;get the size of the caption
Sysget, BorderSize, 46 ;get the size of the border
CaptionSize += BorderSize

WindowY =
WindowX =
WindowWidth =
WindowHeight=
WindowXBuffer = 
WindowYBuffer = 

GoSub,createGroups

  ;hotkey definitions:
  If UseCommand
    Hotkey, %CommandHotkey%, Command

  If MButtonDrag
    Hotkey, MButton, MButtonMove

  If UseFastMove
    GoSub,DefineHotkeys

  MPFlag := True 
  Settimer, MousePosition, 100
  ;Settimer,Helper2,100


  Hotkey,RButton,NextGrid
  Hotkey,RButton,off
  Hotkey,Esc,cancel
  Hotkey,Esc,off

#maxthreadsperhotkey 10
#singleinstance,force
#InstallMouseHook 
#InstallKeybdHook


  return

;*******************Drop Zone Mode 

DropZoneMode:  
  DropZoneModeFlag := true
  gosub,showgroups
  Hotkey,RButton,on
  Hotkey,Esc,on
  Canceled := False
  CoordMode,Mouse,Screen
  loop
  {
    If Canceled
      {
      Critical, on
      Gui,2:Hide
      Hotkey,RButton,off
      Hotkey,Esc,off
      DropZoneModeFlag := false
      return      
      }  
  
    GetKeyState,State,%hotkey%,P
    If State = U
        break
    
    MouseGetPos, MouseX, MouseY, window,
    flagLButton:=true
    Critical, on
    SetBatchLines, 10ms
    loop,%NGroups%
    {
      TriggerTop    := %A_Index%TriggerTop
      TriggerBottom := %A_Index%TriggerBottom
      TriggerRight  := %A_Index%TriggerRight
      TriggerLeft   := %A_Index%TriggerLeft

      If (MouseY >= TriggerTop)
        If (MouseY <= TriggerBottom)
          If (MouseX <= TriggerRight)
            If (MouseX >= TriggerLeft)
            {
            
              GetGrid(A_Index)
              
              If (GridTop = "AlwaysOnTop" OR GridTop = "Run")
                {
                GridTop := TriggerTop
                GridLeft := TriggerLeft
                GridWidth := TriggerRight - TriggerLeft
                GridHeight := TriggerBottom - TriggerTop
                }
              If (GridTop = "Maximize")
                {
                GridTop := GetMonitorTop(MouseX,MouseY)
                GridLeft := GetMonitorLeft(MouseX,MouseY)
                GridWidth := GetMonitorRight(MouseX,MouseY) - GetMonitorLeft(MouseX,MouseY)
                GridHeight := GetMonitorBottom(MouseX,MouseY) - GetMonitorTop(MouseX,MouseY)
                }         
              If not canceled
              {
                Gui, 2: +ToolWindow +AlwaysOnTop -Disabled -SysMenu -Caption
                Gui, 2:show, x%GridLeft% y%GridTop% w%GridWidth% h%GridHeight% NoActivate
              }
              flagLButton:=false
              break
            }
    }
    Critical, off
    if flagLButton
      Gui,2:Hide  
  }   
  DropZoneModeFlag := false 
  Gui,2:Hide
  Hotkey,RButton,off
  Hotkey,Esc,off
  GoSub,SnapWindow
  Gosub,hidegroups
  return
  
cancel:
  if not canceled
    {
    canceled := True 
    GoSub, HideGroups
    Gui,2:Hide
    }
  return
  
;*******************Mbutton method

MButtonMove:
  CoordMode,Mouse,Screen
  MouseGetPos, OldMouseX, OldMouseY, window,
  WinGetTitle,WinTitle,ahk_id %Window%
  WinGetClass,WinClass,ahk_id %Window%
  WinGetPos,,,WinWidth,,ahk_id %Window%
  WinGet,WindowId,Id,ahk_id %Window%
  KeyWait,MButton,T0.3
  If Winclass in %Exceptions%
  {
    send,{MButton down}
    Keywait,mbutton
    send,{mbutton up}
    Return
  }
  if errorlevel = 0
    {
    send,{MButton}
    return
    }
  Winactivate, ahk_id %window%
  Hotkey = MButton
  GoSub, DropZoneMode
  return

;**********************edge/lbutton method

MousePosition:
  Settimer, MousePosition,off

  if MousePositionLock
    return

  KeyWait, LButton,U
  KeyWait, LButton,D 
  ;;ADICIONADO
  ;;gui,show,HIDE

  SetBatchLines, -1

  CoordMode,Mouse,Relative
  MouseGetPos, OldMouseX, OldMouseY, MouseWin,
  WinGetPos, WinLeft, WinTop, WinWidth, WinHeight,ahk_id %MouseWin%
  WinGetTitle,Wintitle,ahk_id %mousewin%
  WinGetClass,WinClass,ahk_id %mousewin%
  WinGet,WindowId,Id,ahk_id %mousewin%
  
  If Winclass in %Exceptions%
    Return

  If (OldMouseY > CaptionSize OR OldMouseY <= BorderSize + 1 
      OR WinTitle = "" OR WinClass = "Shell_TrayWnd" 
      OR WinClass = "Progman" or WinClass = "DV2ControlHost")
  {
    Settimer, MousePosition,10
    return
  }

  If (TitleSize < WinWidth - 40 AND LButtonDrag
      AND OldmouseX > CaptionSize AND OldMouseX < TitleSize)
    {
    Hotkey = LButton
    send {LButton up} 
    GoSub,DropZoneMode
    Settimer, MousePosition,10
    return
    }

  if not EdgeDrag
    {
      settimer, MousePosition,10
      return
    }
  SetBatchLines, 10ms


MousePosition2:

  CoordMode,Mouse,Screen
  MouseGetPos, MouseX, MouseY

  GetKeyState, State, LButton, P
  If (state = "U" or MousePositionLock)
  {
    SetTimer, EdgeMove, Off
    EdgeFlag := True
    Settimer, MousePosition,10
    return
  }

  If (MouseY <= 2 OR MouseX <= 2 OR MouseY >= ScreenHeight -2 OR MouseX >= ScreenWidth -2)
    If EdgeFlag
    {
      settimer, EdgeMove, %EdgeTime%
      EdgeFlag := False
      GoTo,MousePosition2
      return
    }
    else
    {
      sleep,100
      GoTo,MousePosition2
      return
    }
  SetTimer, EdgeMove, Off
  EdgeFlag := True
  sleep,100
  GoSub,MousePosition2
  return

edgemove:
  SetTimer, EdgeMove, Off
  HotKey = LButton
  send {LButton up}
  MousePositionLock := true
  SetBatchLines, -1
  GoSub,DropZoneMode
  MousePositionLock := false
  EdgeFlag := True
  Settimer, MousePosition,10
  return

;**********************Snap Window to Grid

SnapWindow:
  send, {LButton up}
  CoordMode,Mouse,Screen
  Moved := False
  loop %NGroups%
  {
    triggerTop := %A_Index%TriggerTop
    triggerBottom := %A_Index%TriggerBottom
    triggerRight := %A_Index%TriggerRight
    triggerLeft := %A_Index%TriggerLeft

    GridBottom :=0
    GridRight  :=0
    GridTop    :=0
    GridLeft   :=0

    GetGrid(A_Index)
    
    If (MouseY >= triggerTop)
      If (MouseY <= triggerBottom)
        If (MouseX <= triggerRight)
          If (MouseX >= triggerLeft)
            {
            If GridTop = AlwaysOnTop
              {
              WinSet, AlwaysOnTop, Toggle,A 
              return
              }
            If GridTop = Maximize
              {
              winget,state,minmax,A
              if state = 1
                WinRestore,A
              else
                PostMessage, 0x112, 0xF030,,, A,
              return 
              }
            If GridTop = Run
              {
              Run,%GridLeft% ,%GridRight%
              return              
              }
            WinRestore,A
            Moved := True
            WinMove, A, ,%GridLeft%,%GridTop%, % GridRight - GridLeft,% GridBottom - GridTop,
            break
            }  
  }
  If Moved
    StoreWindowState(WindowID,WinLeft,WinTop,WinWidth,WinHeight)
  gosub, hidegroups
  return

GetGrid(number)
  {
  global
  
  MouseGetPos, MouseX, MouseY, window,
  
  GridTop := %number%GridTop
  GridBottom := %number%GridBottom
  GridRight := %number%GridRight
  GridLeft := %number%GridLeft

  If GridTop = WindowHeight
    {
    MonitorBottom := GetMonitorBottom(MouseX, MouseY)
    GridTop := MouseY        
    If (GridTop + WinHeight > MonitorBottom)
      GridTop := MonitorBottom - WinHeight
    GridBottom := GridTop + WinHeight
    }
    
  If GridLeft = WindowWidth
    {
    MonitorRight := GetMonitorRight(MouseX, MouseY)
    GridLeft := MouseX
    If (GridLeft + WinWidth > MonitorRight)
      GridLeft := MonitorRight - WinWidth
    GridRight := GridLeft + WinWidth       
    }   

  If GridTop = restore
    {
    data := GetWindowState(WindowID)
    If data   
      { 
      GridLeft  := WindowX
      GridRight := WindowX + WindowWidth
      GridTop   := WindowY
      GridBottom:= WindowY + WindowHeight 
      }
    else
      {
      GridLeft  := WinLeft
      GridRight := WinLeft + WinWidth
      GridTop   := WinTop
      GridBottom:= WinTop + WinHeight 
      }
    }
  GridWidth  := GridRight - GridLeft 
  GridHeight := GridBottom - GridTop
  }


;*************************************************************************Groups

showgroups:
  if not ShowGroupsFlag
    return
  settimer,showgroups, off 
  ;Gui,+ToolWindow +AlwaysOnTop -Disabled -SysMenu -Caption
  ;;ADICIONADO
  WinMove,ahk_id %GuiId%,,%ScreenLeft%,%ScreenTop%,%ScreenRight%,%ScreenBottom%
  WinSet, AlwaysOnTop, On,ahk_id %GuiId%
  ;Gui,Show, X%ScreenLeft% Y%ScreenTop% W%ScreenWidth% H%ScreenHeight% noactivate,GridMove Drop Zone
  sleep,100
  GroupsShowing := True
  return

Hidegroups:
  ;;ADICIONADO
  WinMove,ahk_id %GuiId%,,% ScreenLeft -1,% ScreenTop -1, 1, 1
  ;Gui,hide
  return

creategroups:
  gui,destroy
  Gui, Font, s15 cRed, Arial
  loop,%NGroups%
  {
    ;TriggerTop    := %A_Index%TriggerTop - 11 - ScreenTop
    TriggerTop    := %A_Index%TriggerTop - ScreenTop
    ;TriggerBottom := %A_Index%TriggerBottom - ScreenTop +1
    TriggerBottom := %A_Index%TriggerBottom - ScreenTop
    TriggerLeft   := %A_Index%TriggerLeft - ScreenLeft
    ;TriggerRight  := %A_Index%TriggerRight - ScreenLeft +1
    TriggerRight  := %A_Index%TriggerRight - ScreenLeft
    ;TriggerHeight := TriggerBottom - TriggerTop +1
    TriggerHeight := TriggerBottom - TriggerTop 
    ;TriggerWidth  := TriggerRight - TriggerLeft +1
    TriggerWidth  := TriggerRight - TriggerLeft
    GridTop       := %A_Index%GridTop
    GridLeft      := %A_Index%GridLeft
    
    TextTop := %A_Index%TriggerTop - ScreenTop
    TextTop += Round((%A_Index%TriggerBottom - %A_Index%TriggerTop) / 2 )- 11
    TextLeft := %A_Index%TriggerLeft - ScreenLeft
    TextLeft += Round((%A_Index%TriggerRight - %A_Index%TriggerLeft) / 2) - 5
    RestoreLeft := TextLeft - 50
    Gui, add, Picture, Y%TriggerTop%    X%TriggerLeft% W%TriggerWidth% H1 ,Images\Grid.bmp
    Gui, add, Picture, Y%TriggerBottom% X%TriggerLeft% W%TriggerWidth% H1 ,Images\Grid.bmp
    Gui, add, Picture, Y%TriggerTop% X%TriggerLeft%  W1 H%TriggerHeight% ,Images\Grid.bmp
    Gui, add, Picture, Y%TriggerTop% X%TriggerRight% W1 H%TriggerHeight% ,Images\Grid.bmp
    
    If GridTop is number
      If GridLeft is number
        If A_Index < 10 
          Gui, add, text, X%TextLeft% Y%TextTop% ,%A_Index%
        else
          Gui, add, text,% "X" TextLeft - 6 " Y" TextTop,%A_Index%

    If GridTop = WindowHeight
      Gui, add, text, X%TextLeft% Y%TextTop% ,%A_Index%
    If GridLeft = WindowWidth
      Gui, add, text, X%TextLeft% Y%TextTop% ,%A_Index%
    If Gridtop = Restore
      Gui, add, text, X%RestoreLeft% Y%TextTop% ,%A_Index%-Restore
    If GridTop = Maximize 
      Gui, add, text, X%RestoreLeft% Y%TextTop% ,%A_Index%-Maximize
    If GridTop = AlwaysOnTop
      Gui, add, text, X%RestoreLeft% Y%TextTop% ,%A_Index%-On Top
    If Gridtop = Run
    {
      GridBottom := %A_Index%GridBottom
      GridLeft := %A_Index%GridLeft
      If (%A_Index%GridBottom != "")
        Gui, add, text, X%RestoreLeft% Y%TextTop% ,%A_Index%-%GridBottom%
      else
        Gui, add, text, X%RestoreLeft% Y%TextTop% ,%A_Index%-%GridLeft%
    }
  }
  Gui,+ToolWindow +AlwaysOnTop -Disabled -SysMenu -Caption
  Gui,Margin,0,0
  Gui,color,fffffa
  ;;ADICIONADO
  WinGet,temp_window_id,Id,A
  Gui,show,x0 y0 w0 h0 noactivate,GridMove Drop Zone 0xba
  ;Gui, +lastfound
  WinGet,GuiId,Id,GridMove Drop Zone 0xba
  WinMove,ahk_id %GuiId%,,% ScreenLeft -1,% ScreenTop -1, 1, 1
  ;;
  WinSet, TransColor, fffffa,GridMove Drop Zone 0xba
  ;;Gui,hide
  Gui,2: +ToolWindow +AlwaysOnTop -Disabled -SysMenu -Caption
  Gui,2: Margin,0,0
  Gui,2: +lastfound
  return
 
;***********************************************************Aditional Functions

ExitProgram:
  ExitApp

ReloadProgram:
  Reload
  return

CreateTemplatesMenu()
  {
  global GridName
  Menu, Templates, add, 2-part grid Vertical  ,Template-2PartVertical
  Menu, Templates, add, 2-part grid Horizontal,Template-2PartHorizontal
  Menu, Templates, add, 3-part grid           ,Template-3part
  Menu, Templates, add, 4-part grid           ,Template-4part
  Menu, Templates, add, Edge grid             ,Template-edge
  Menu, Templates, add, Dual-Screen grid      ,Template-DualScreen
  Loop,Grids\*.grid
    Menu, Templates, add, %A_LoopFileName%    ,Template-Grids
  ;Menu, Templates, add, Browse...             ,Template-Browse
    
  stringgetpos,out_pos,gridname,\,R1
  if out_pos <= 0
    stringgetpos,out_pos,gridname,/,R1
  if out_pos <= 0
    return
  stringlen, len, gridname
  StringRight,out_GridName,gridname,% len - out_pos -1 
  IfExist Grids\%out_GridName%
    menu,templates,check,%out_GridName%
  }
  
CreateHotkeysMenu()
  {
  global UseCommand
  global CommandHotKey
  global UseFastMove
  global FastMoveModifiers
  Menu, Hotkeys, add, Use Command, Hotkeys_UseCommand 
  Menu, Hotkeys, add, Command Hotkey, Hotkeys_CommandHotkey
  Menu, Hotkeys, add, Use Fast Move, Hotkeys_UseFastMove
  Menu, Hotkeys, add, Fast Move Modifiers, Hotkeys_FastMoveModifiers
  If UseCommand
    Menu,Hotkeys,check, Use Command
  else
    Menu,Hotkeys,Disable, Command Hotkey,
  If UseFastMove
    Menu,Hotkeys,check, Use Fast Move
  else
    Menu,Hotkeys,Disable, Fast Move Modifiers
  }

Hotkeys_UseCommand:
  If UseCommand
      UseCommand := False
  else
      UseCommand := True
  GoSub,WriteIni
  Reload
  return


Hotkeys_UseFastMove:
  If UseFastMove
      UseFastMove := False
  else
      UseFastMove := True
  GoSub,WriteIni
  Reload
  return

Hotkeys_CommandHotkey:
  inputbox,input, Input the hotkey, Select the hotkey you'd like to use to make GridMove go into Command Mode. ^ stands for ctrl`, + stands for shift`, ! stands for alt and # stands for Windows key.`nE.G.: ^#g stands for ctrl+win+g. Notice that the order of the modifiers doesn't matter.,,,,,,,,%CommandHotkey%
  if errorlevel <> 0
    return
  CommandHotkey := input
  GoSub, WriteIni
  reload
  return

Hotkeys_FastMoveModifiers:
  inputbox,input, Input the modifier keys for Fast Move, Please input the modifiers for Fast Move.`n^ stands for ctrl`, + stands for shift`,`n! stands for alt and # stands for Win key.`nE.G. : ^# will make ctrl+windows+1 move the active window to the first area.`nNotice that their order doesn't matter.,,,,,,,,%FastMoveModifiers%
  if errorlevel <> 0
    return
  FastMoveModifiers := input
  GoSub, WriteIni
  Reload
  return

CreateOptionsMenu()
  {
  global LButtonDrag
  global MButtonDrag
  global EdgeDrag
  global ShowGridFlag
  global ShowGroupsFlag
  Menu, Options, add,  Show Grid, Options_ShowGrid
  Menu, Options, add, Use Drag On Window Title method, Options_LButtonDrag
  Menu, Options, add, Use Drag With Middle Button method, Options_MButtonDrag
  Menu, Options, add, Use Drag Window To Edge method, Options_EdgeDrag
  Menu, Options, add, Set Edge Time, Options_EdgeTime
  Menu, Options, add, Set Title Size, Options_TitleSize
  Menu, Options, add, Set Grid Order, Options_GridOrder
  If LButtonDrag
    Menu,Options,check, Use Drag On Window Title method
  else
    Menu,Options,Disable, Set Title Size,
  If MButtonDrag
    Menu,Options,check, Use Drag With Middle Button method
  If EdgeDrag
    Menu,Options,check, Use Drag Window To Edge method
  else
    Menu,Options,Disable, Set Edge Time
  If ShowGroupsFlag
    Menu, Options, Check,  Show Grid
  }

Options_GridOrder:
  inputbox,input, Input an order for the grid Cycle, The following grids are available: `n2PartVertical`,2PartHorizontal`,3Part`,4part`,Edge`,Dualscreen`nThe Grid names must be separated by commas, without spaces.`n.Grid file names can also be used.,,,,,,,,%GridOrder%
  if errorlevel <> 0
    return
  GridOrder := input
  GoSub, WriteIni
  return
  
Options_LButtonDrag:
  If LButtonDrag
    {
    Menu,Options,Uncheck, Use Drag On Window Title method
    LButtonDrag := false
    Menu,Options,Disable, Set Title Size,
    }
  else
    {
    Menu,Options,check, Use Drag On Window Title method
    LButtonDrag := true
    Menu,Options,Enable, Set Title Size,
    }
  GoSub, WriteIni
  return

Options_mbuttonDrag:
  If mbuttonDrag
    mbuttonDrag := false
  else
    mbuttonDrag := true
  GoSub, WriteIni
  reload
  return
  
Options_EdgeDrag:
  If EdgeDrag
    {
    EdgeDrag := false
    Menu,Options,Uncheck, Use Drag Window To Edge method
    Menu,Options,Disable, Set Edge Time
    }
  else
    {
    Menu,Options,check, Use Drag Window To Edge method
    EdgeDrag := true
    Menu,Options,Enable, Set Edge Time
    }
  GoSub, WriteIni
  return  

Options_EdgeTime:
  inputbox,input, Input the delay for the edge method, Please input the delay before the grid comes up `nwhen a window is dragged to the edge of the screen,,,,,,,,%EdgeTime%
  if errorlevel <> 0
    return
  EdgeTime := input
  GoSub, WriteIni
  return
  
Options_TitleSize:
  inputbox,input, Input the size of the title of windows, Please input the number of pixels to be considered as the title of a window`, for the LButton drag method.,,,,,,,,%TitleSize%
  if errorlevel <> 0
    return
  TitleSize := input
  GoSub, WriteIni
  return  
  
Options_ShowGrid:
  If ShowGroupsFlag
    {
    ShowGroupsFlag := false
    Menu,options, Uncheck,  Show Grid
    }  
  else
    {
    ShowGroupsFlag := True
    Menu,options, Check,  Show Grid    
    }
  GoSub, WriteIni
  return 

Template-Browse:
  critical
  FileSelectFile, GridName, 1, ., Select .Grid file to open,Grid Files (*.grid) 
  msgbox, here mother
  If Errorlevel <> 0
    return  
  GoSub, ApplyGrid
  critical,off
  return 

Template-Grids:
  GridName = Grids/%A_ThisMenuItem%
  GoSub, ApplyGrid
  Menu,Templates,DeleteAll
  CreateTemplatesMenu()
  Menu,Templates, check,%A_ThisMenuItem%
  return

NextGrid:
  NextGridFlag := False
  NextGrid =
  Loop
  {
    StringLeft,out,GridOrder,1
    If out = ,
      StringTrimLeft,GridOrder,GridOrder,1
    else
      {
      StringRight,out,GridOrder,1
      If out <> ,
        GridOrder =%GridOrder%,
      break
      }
  }
  Loop, Parse,GridOrder,CSV 
  {
    If A_LoopField is space
      continue
      
    If NextGridFlag
    {
      NextGrid := A_LoopField
      AutoTrim,on
      SetEnv,NextGrid,%NextGrid%
      NextGridFlag:= False
    }
    If (A_LoopField = GridName)
      NextGridFlag := True
  }
  If (NextGridFlag OR NextGrid = "")
    {
    StringGetPos, CommaPosition, GridOrder, `,
    StringLeft, NextGrid, GridOrder, %CommaPosition% 
    }
  GridName := NextGrid
  Critical,on
  ;;ADICIONADO
  GoSub,HideGroups
  ;;Gui, Hide
  Gui,2:Hide
  GoSub, ApplyGrid
  GoSub, ShowGroups
  SafeShow := False
  return

ApplyGrid:
  If (GridName = "3part" OR GridName = "4part" 
      OR GridName = "edge" OR Gridname = "DualScreen" 
      OR Gridname = "2PartHorizontal" OR Gridname = "2PartVertical")
    GoSub,Template-%GridName%
  else
    GoSub, CreateGridFromFile
  return

CreateGridFromFile:
  Menu,Templates,DeleteAll
  CreateTemplatesMenu()
  ;Menu, Templates, Check, Browse...
  
  GoSub, HideGroups
  Gui,destroy
  Gui,2:destroy
  IniRead,NGroups,%GridName%,Groups,NumberOfGroups,Error
  If NGroups = "error"
    {
    MsgBox,There was an error while Opening the grid file.`nReverting to Default Config. ErrorCode:001
    GoSub, Template-3Part
    return
    } 
  ErrorLevel := False
  loop,%NGroups%
  {
    if a_index = "0"
      continue
    TriggerTop    = %A_Index%TriggerTop
    TriggerBottom = %A_Index%TriggerBottom
    TriggerRight  = %A_Index%TriggerRight
    TriggerLeft   = %A_Index%TriggerLeft
      
    GridTop    = %A_Index%GridTop
    GridBottom = %A_Index%GridBottom
    GridRight  = %A_Index%GridRight
    GridLeft   = %A_Index%GridLeft
      
    IniRead,%TriggerTop%    ,%GridName%,%A_Index%,TriggerTop,Error
    IniRead,%TriggerBottom% ,%GridName%,%A_Index%,TriggerBottom,Error
    IniRead,%TriggerLeft%   ,%GridName%,%A_Index%,TriggerLeft,Error
    IniRead,%TriggerRight%  ,%GridName%,%A_Index%,TriggerRight,Error
               
    IniRead,%GridTop%       ,%GridName%,%A_Index%,GridTop,Error
    IniRead,%GridBottom%    ,%GridName%,%A_Index%,GridBottom,Error
    IniRead,%GridLeft%      ,%GridName%,%A_Index%,GridLeft,Error
    IniRead,%GridRight%     ,%GridName%,%A_Index%,GridRight,Error

    If (%TriggerTop%="Error" OR %TriggerBottom%="Error" 
        OR TriggerLeft="Error" OR %TriggerRight%="Error" 
        OR %GridTop%="Error" OR %GridBottom%="Error" 
        OR %GridLeft%="Error" OR %GridRight%="Error")
      {
      ErrorCode := A_Index
      ErrorLevel := True
      }
  }
  If ErrorLevel
    {
    MsgBox,There was an error while reading the grid file.`nReverting to default config. (Read error on grid element %ErrorCode%)
    GoSub, Template-3Part
    GridName = 3Part
    return
    }
  evaluateGrid()
  GoSub, CreateGroups
  GoSub, WriteIni
return

GetScreenSize()
  {
  Global 
  ScreenLeft   :=0
  ScreenTop    :=0
  ScreenRight  :=0
  ScreenBottom :=0
  Sysget,MonitorCount,MonitorCount
  
  Loop,%MonitorCount%
  {
    SysGet,monitor,Monitor,%A_Index%
    If (monitorLeft<ScreenLeft)
      ScreenLeft:=monitorLeft
    If (monitorTop<ScreenTop)
      ScreenTop:=monitorTop
    If (monitorRight>ScreenRight)
      ScreenRight:=monitorRight
    If (monitorBottom>ScreenBottom)
      ScreenBottom:=monitorBottom
  }
  ScreenWidth := ScreenRight - ScreenLeft
  ScreenHeight := ScreenBottom - ScreenTop 
  return
  }

GetMonitorRight(MouseX, MouseY)
  {
  SysGet,monitorcount,MonitorCount
  Loop,%monitorcount%
    {
      SysGet,monitor,Monitor,%A_Index%
      If (MouseX <= monitorRight AND MouseX >= monitorLeft 
          AND MouseY >= monitorTop AND MouseY <= monitorBottom)
        return %MonitorRight%
    }
  return error
  }
  
GetMonitorBottom(MouseX, MouseY)
  {
  SysGet,monitorcount,MonitorCount
  Loop,%monitorcount%
    {
      SysGet,monitor,Monitor,%A_Index%
      If (MouseX <= MonitorRight AND MouseX >= MonitorLeft 
          AND MouseY >= monitorTop AND MouseY <= monitorBottom)
        return, %MonitorBottom%
    }
  return error
  }
  
GetMonitorLeft(MouseX, MouseY)
  {
  SysGet,monitorcount,MonitorCount
  Loop,%monitorcount%
    {
      SysGet,monitor,Monitor,%A_Index%
      If (MouseX <= MonitorRight AND MouseX >= MonitorLeft 
          AND MouseY >= monitorTop AND MouseY <= monitorBottom)
        return, %MonitorLeft%
    }
  return error
  }
  
GetMonitorTop(MouseX, MouseY)
  {
  SysGet,monitorcount,MonitorCount
  Loop,%monitorcount%
    {
      SysGet,monitor,Monitor,%A_Index%
      If (MouseX <= MonitorRight AND MouseX >= MonitorLeft 
          AND MouseY >= monitorTop AND MouseY <= monitorBottom)
        return, %MonitorTop%
    }
  return error
  }

StoreWindowState(WindowID,WindowX,WindowY,WindowWidth,WindowHeight)
  {
  global WindowIdBuffer
  global WindowXBuffer
  global WindowYBuffer
  global WindowWidthBuffer
  global WindowHeightBuffer
  WindowIdBuffer = %WindowId%,%WindowIdBuffer%
  WindowXBuffer = %WindowX%,%WindowXBuffer%
  WindowYBuffer = %WindowY%,%WindowYBuffer%
  WindowWidthBuffer = %WindowWidth%,%WindowWidthBuffer%
  WindowHeightBuffer = %WindowHeight%,%WindowHeightBuffer%
  return
  }
  
GetWindowState(WindowId)
  {
  global
  StringSplit, WindowX     , WindowXBuffer     , `,,,
  StringSplit, WindowY     , WindowYBuffer     , `,,,
  StringSplit, WindowWidth , WindowWidthBuffer , `,,,
  StringSplit, WindowHeight, WindowHeightBuffer, `,,,
  loop, parse, WindowIdBuffer,CSV
    {
    if a_loopfield is space
      continue
    if (WindowId = A_LoopField) 
      {
      WindowX := WindowX%A_Index%
      WindowY := WindowY%A_Index%
      WindowWidth  := WindowWidth%A_Index%
      WindowHeight := WindowHeight%A_Index%
      return true
      }
    }
  return false  
  }

evaluateGrid()
  {
  global
  count := 0
  loop,%NGroups%
    {
    value := A_Index - count

    %value%TriggerTop    := eval(%A_Index%TriggerTop)
    %value%TriggerBottom := eval(%A_Index%TriggerBottom)
    %value%TriggerLeft   := eval(%A_Index%TriggerLeft)
    %value%TriggerRight  := eval(%A_Index%TriggerRight)
    
    If (%A_Index%GridTop = "Run")
    {
      %value%GridTop    := %A_Index%GridTop
      %value%GridBottom := %A_Index%GridBottom
      %value%GridLeft   := %A_Index%GridLeft
      %value%GridRight  := %A_Index%GridRight
      continue
    }


    %value%gridTop    := eval(%A_Index%GridTop)
    %value%gridBottom := eval(%A_Index%GridBottom)
    %value%gridLeft   := eval(%A_Index%GridLeft)
    %value%gridRight  := eval(%A_Index%GridRight)
    
    ;msgbox,% " gr: " . %value%GridRight . " gl: " . %value%GridLeft . " gb: " . %value%GridBottom . " gt: " . %value%GridTop . " tt:" . %value%TriggerTop . " tl:" . %value%TriggerLeft . " tr:" . %value%TriggerRight . " tb:" . %value%TriggerBottom
    if (%value%TriggerTop = "error" OR %value%TriggerBottom = "Error" OR %value%TriggerLeft = "error" OR %value%TriggerRight = "error" OR %value%GridTop = "error" OR %value%GridBottom = "Error" OR %value%GridLeft = "error" OR %value%GridRight = "error")
      {
      count += 1
      continue
      }
    }
  ngroups -= count
  }

Getmonitorsizes()
  {
  global 
  sysget,monitorCount,MonitorCount
  
  loop,%monitorCount%
    {
    sysget,monitorReal,Monitor,%A_Index%
    sysget,monitor,MonitorWorkArea,%A_Index%
    monitor%a_Index%Left   :=MonitorLeft
    monitor%a_Index%Bottom :=MonitorBottom
    monitor%a_Index%Right  :=MonitorRight
    monitor%a_Index%Top    :=MonitorTop
    monitor%a_Index%Width  :=MonitorRight - MonitorLeft
    monitor%a_Index%Height :=MonitorBottom - MonitorTop
    
    monitorreal%A_Index%Left   :=MonitorRealLeft
    monitorreal%A_Index%Bottom :=MonitorRealBottom
    monitorreal%A_Index%Right  :=MonitorRealRight
    monitorreal%A_Index%Top    :=MonitorRealTop
    monitorreal%A_Index%Width  :=MonitorRealRight - MonitorRealLeft
    monitorreal%A_Index%Height :=MonitorRealBottom - MonitorRealTop
    } 
  return
  }
  
  #include gridMoveP2.ahk
  #include calc.ahk
  #include command.ahk
  #include helper.ahk
